﻿using System;
using System.Collections.Generic;
using System.IO;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Hosting;
using MVC_Core_PhysicalFileResult.Models;
using Microsoft.AspNetCore.StaticFiles;

namespace MVC_Core_PhysicalFileResult.Controllers
{
    public class HomeController : Controller
    {
        private IHostingEnvironment Environment;

        public HomeController(IHostingEnvironment _environment)
        {
            Environment = _environment;
        }

        public IActionResult Index()
        {
            //Fetch all files in the Folder (Directory).
            string[] filePaths = Directory.GetFiles(Path.Combine(this.Environment.WebRootPath, "Files/"));

            //Copy File names to Model collection.
            List<FileModel> files = new List<FileModel>();
            foreach (string filePath in filePaths)
            {
                files.Add(new FileModel { FileName = Path.GetFileName(filePath) });
            }

            return View(files);
        }

        public PhysicalFileResult DownloadFile(string fileName)
        {
            //Determine the Content Type of the File.
            string contentType = "";
            new FileExtensionContentTypeProvider().TryGetContentType(fileName, out contentType);

            //Build the File Path.
            string path = Path.Combine(this.Environment.WebRootPath, "Files/") + fileName;


            //Send the File to Download.
            return new PhysicalFileResult(path, contentType);
        }
    }
}